Index: gcc/testsuite/gcc.target/i386/pr55142-2.c
===================================================================
--- gcc/testsuite/gcc.target/i386/pr55142-2.c	(.../tags/gcc_4_7_2_release)	(wersja 0)
+++ gcc/testsuite/gcc.target/i386/pr55142-2.c	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -0,0 +1,33 @@
+/* { dg-do compile { target { ! { ia32 } } } } */
+/* { dg-require-effective-target fpic } */
+/* { dg-options "-O3 -mx32 -fpic" } */
+/* { dg-final { scan-assembler-not "movl\[\\t \]*%.*,\[\\t \]*-1073742592\\(%r(.x|.i|.p|\[1-9\]*)\\)" } } */
+
+typedef int int32_t;
+typedef unsigned int uint32_t;
+typedef uint32_t Elf32_Word;
+typedef int32_t Elf32_Sword;
+typedef uint32_t Elf32_Addr;
+typedef struct {
+  Elf32_Sword d_tag;
+  union {
+    Elf32_Word d_val;
+    Elf32_Addr d_ptr;
+  } d_un;
+} Elf32_Dyn;
+struct link_map {
+  Elf32_Dyn *l_ld;
+  Elf32_Dyn *l_info[34 + 16 + 3 + 12 + 11];
+};
+void
+elf_get_dynamic_info (struct link_map *l)
+{
+  Elf32_Dyn *dyn = l->l_ld;
+  Elf32_Dyn **info = l->l_info;
+  typedef Elf32_Word d_tag_utype;
+  while (dyn->d_tag != 0) {
+    if ((d_tag_utype) (0x6ffffeff - dyn->d_tag) < 11)
+      info[(0x6ffffeff - dyn->d_tag) + 34 + 16 + 3 + 12] = dyn;
+    ++dyn;
+  }
+}
Index: gcc/testsuite/gcc.target/i386/avx256-unaligned-load-3.c
===================================================================
--- gcc/testsuite/gcc.target/i386/avx256-unaligned-load-3.c	(.../tags/gcc_4_7_2_release)	(wersja 194650)
+++ gcc/testsuite/gcc.target/i386/avx256-unaligned-load-3.c	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -14,6 +14,6 @@
     c[i] = a[i] * b[i+3];
 }
 
-/* { dg-final { scan-assembler-not "avx_movupd256/1" } } */
-/* { dg-final { scan-assembler "sse2_movupd/1" } } */
+/* { dg-final { scan-assembler-not "avx_loadupd256" } } */
+/* { dg-final { scan-assembler "sse2_loadupd" } } */
 /* { dg-final { scan-assembler "vinsertf128" } } */
Index: gcc/testsuite/gcc.target/i386/avx256-unaligned-store-1.c
===================================================================
--- gcc/testsuite/gcc.target/i386/avx256-unaligned-store-1.c	(.../tags/gcc_4_7_2_release)	(wersja 194650)
+++ gcc/testsuite/gcc.target/i386/avx256-unaligned-store-1.c	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -17,6 +17,6 @@
     d[i] = c[i] * 20.0;
 }
 
-/* { dg-final { scan-assembler-not "avx_movups256/2" } } */
+/* { dg-final { scan-assembler-not "avx_storeups256" } } */
 /* { dg-final { scan-assembler "vmovups.*\\*movv4sf_internal/3" } } */
 /* { dg-final { scan-assembler "vextractf128" } } */
Index: gcc/testsuite/gcc.target/i386/avx256-unaligned-load-4.c
===================================================================
--- gcc/testsuite/gcc.target/i386/avx256-unaligned-load-4.c	(.../tags/gcc_4_7_2_release)	(wersja 194650)
+++ gcc/testsuite/gcc.target/i386/avx256-unaligned-load-4.c	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -14,6 +14,6 @@
     b[i] = a[i+3] * 2;
 }
 
-/* { dg-final { scan-assembler "avx_movups256/1" } } */
-/* { dg-final { scan-assembler-not "avx_movups/1" } } */
+/* { dg-final { scan-assembler "avx_loadups256" } } */
+/* { dg-final { scan-assembler-not "sse_loadups" } } */
 /* { dg-final { scan-assembler-not "vinsertf128" } } */
Index: gcc/testsuite/gcc.target/i386/avx256-unaligned-store-2.c
===================================================================
--- gcc/testsuite/gcc.target/i386/avx256-unaligned-store-2.c	(.../tags/gcc_4_7_2_release)	(wersja 194650)
+++ gcc/testsuite/gcc.target/i386/avx256-unaligned-store-2.c	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -24,6 +24,6 @@
     }
 }
 
-/* { dg-final { scan-assembler-not "avx_movdqu256/2" } } */
+/* { dg-final { scan-assembler-not "avx_storedqu256" } } */
 /* { dg-final { scan-assembler "vmovdqu.*\\*movv16qi_internal/3" } } */
 /* { dg-final { scan-assembler "vextract.128" } } */
Index: gcc/testsuite/gcc.target/i386/pr55597.c
===================================================================
--- gcc/testsuite/gcc.target/i386/pr55597.c	(.../tags/gcc_4_7_2_release)	(wersja 0)
+++ gcc/testsuite/gcc.target/i386/pr55597.c	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -0,0 +1,18 @@
+/* { dg-do compile { target { ! { ia32 } } } } */
+/* { dg-require-effective-target fpic } */
+/* { dg-options "-O2 -fPIC -mx32" } */
+
+struct initial_sp
+{
+  void *sp;
+  int mask;
+};
+
+__thread struct initial_sp __morestack_initial_sp;
+
+void foo (int *);
+
+void __morestack_release_segments (void)
+{
+  foo (&__morestack_initial_sp.mask);
+}
Index: gcc/testsuite/g++.old-deja/g++.jason/enum6.C
===================================================================
--- gcc/testsuite/g++.old-deja/g++.jason/enum6.C	(.../tags/gcc_4_7_2_release)	(wersja 194650)
+++ gcc/testsuite/g++.old-deja/g++.jason/enum6.C	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -7,10 +7,10 @@
 // enum-size attributes should only be emitted if there are values of
 // enum type that can escape the compilation unit, gcc cannot currently
 // detect this; if this facility is added then this linker option should
-// not be needed.  arm-*-linux*eabi should be a good approximation to
+// not be needed.  arm-*-linux*eabi* should be a good approximation to
 // those platforms where the EABI supplement defines enum values to be
 // 32 bits wide.
-// { dg-options "-fshort-enums -Wl,--no-enum-size-warning" { target arm*-*-linux*eabi } }
+// { dg-options "-fshort-enums -Wl,--no-enum-size-warning" { target arm*-*-linux*eabi* } }
 
 #include <limits.h>
 
Index: gcc/testsuite/g++.old-deja/g++.other/enum4.C
===================================================================
--- gcc/testsuite/g++.old-deja/g++.other/enum4.C	(.../tags/gcc_4_7_2_release)	(wersja 194650)
+++ gcc/testsuite/g++.old-deja/g++.other/enum4.C	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -9,10 +9,10 @@
 // enum-size attributes should only be emitted if there are values of
 // enum type that can escape the compilation unit, gcc cannot currently
 // detect this; if this facility is added then this linker option should
-// not be needed.  arm-*-linux*eabi should be a good approximation to
+// not be needed.  arm-*-linux*eabi* should be a good approximation to
 // those platforms where the EABI supplement defines enum values to be
 // 32 bits wide.
-// { dg-options "-fshort-enums -Wl,--no-enum-size-warning" { target arm*-*-linux*eabi } }
+// { dg-options "-fshort-enums -Wl,--no-enum-size-warning" { target arm*-*-linux*eabi* } }
 
 enum E { 
   a = -312
Index: gcc/testsuite/g++.old-deja/g++.law/enum9.C
===================================================================
--- gcc/testsuite/g++.old-deja/g++.law/enum9.C	(.../tags/gcc_4_7_2_release)	(wersja 194650)
+++ gcc/testsuite/g++.old-deja/g++.law/enum9.C	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -7,10 +7,10 @@
 // enum-size attributes should only be emitted if there are values of
 // enum type that can escape the compilation unit, gcc cannot currently
 // detect this; if this facility is added then this linker option should
-// not be needed.  arm-*-linux*eabi should be a good approximation to
+// not be needed.  arm-*-linux*eabi* should be a good approximation to
 // those platforms where the EABI supplement defines enum values to be
 // 32 bits wide.
-// { dg-options "-fshort-enums -Wl,--no-enum-size-warning" { target arm*-*-linux*eabi } }
+// { dg-options "-fshort-enums -Wl,--no-enum-size-warning" { target arm*-*-linux*eabi* } }
 
 // GROUPS passed enums
   extern "C" int printf (const char *, ...);
Index: gcc/testsuite/lib/gcc-dg.exp
===================================================================
--- gcc/testsuite/lib/gcc-dg.exp	(.../tags/gcc_4_7_2_release)	(wersja 194650)
+++ gcc/testsuite/lib/gcc-dg.exp	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -211,9 +211,13 @@
 proc gcc-dg-prune { system text } {
     global additional_prunes
 
+    # Extra prune rules that will apply to tests defined in a .exp file.
+    # Always remember to clear it in .exp file after executed all tests.
+    global dg_runtest_extra_prunes
+
     set text [prune_gcc_output $text]
 
-    foreach p $additional_prunes {
+    foreach p "$additional_prunes $dg_runtest_extra_prunes" {
 	if { [string length $p] > 0 } {
 	    # Following regexp matches a complete line containing $p.
 	    regsub -all "(^|\n)\[^\n\]*$p\[^\n\]*" $text "" text
@@ -672,6 +676,7 @@
 	    set additional_files ""
 	    set additional_sources ""
 	    set additional_prunes ""
+	    set dg_runtest_extra_prunes ""
 	    set shouldfail 0
 	    if [info exists compiler_conditional_xfail_data] {
 		unset compiler_conditional_xfail_data
@@ -745,7 +750,7 @@
     # Process the dg- directive, including adding the regular expression
     # to the new message entry in dg-messages.
     set msgcnt [llength ${dg-messages}]
-    catch { eval $msgproc $dgargs }
+    eval $msgproc $dgargs
 
     # If the target expression wasn't satisfied there is no new message.
     if { [llength ${dg-messages}] == $msgcnt } {
@@ -809,3 +814,4 @@
 }
 
 set additional_prunes ""
+set dg_runtest_extra_prunes ""
Index: gcc/testsuite/lib/target-supports.exp
===================================================================
--- gcc/testsuite/lib/target-supports.exp	(.../tags/gcc_4_7_2_release)	(wersja 194650)
+++ gcc/testsuite/lib/target-supports.exp	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -2993,7 +2993,7 @@
 	    set et_vect_widen_mult_qi_to_hi_saved 0
 	}
         if { [istarget powerpc*-*-*]
-              || ([istarget arm*-*-*] && [check_effective_target_arm_neon]) } {
+              || ([istarget arm*-*-*] && [check_effective_target_arm_neon_ok]) } {
             set et_vect_widen_mult_qi_to_hi_saved 1
         }
     }
@@ -3027,7 +3027,7 @@
 	      || [istarget ia64-*-*]
 	      || [istarget i?86-*-*]
 	      || [istarget x86_64-*-*]
-              || ([istarget arm*-*-*] && [check_effective_target_arm_neon]) } {
+              || ([istarget arm*-*-*] && [check_effective_target_arm_neon_ok]) } {
             set et_vect_widen_mult_hi_to_si_saved 1
         }
     }
@@ -3048,7 +3048,7 @@
     } else {
         set et_vect_widen_mult_qi_to_hi_pattern_saved 0
         if { [istarget powerpc*-*-*]
-              || ([istarget arm*-*-*] && [check_effective_target_arm_neon]) } {
+              || ([istarget arm*-*-*] && [check_effective_target_arm_neon_ok]) } {
             set et_vect_widen_mult_qi_to_hi_pattern_saved 1
         }
     }
@@ -3073,7 +3073,7 @@
               || [istarget ia64-*-*]
               || [istarget i?86-*-*]
               || [istarget x86_64-*-*]
-              || ([istarget arm*-*-*] && [check_effective_target_arm_neon]) } {
+              || ([istarget arm*-*-*] && [check_effective_target_arm_neon_ok]) } {
             set et_vect_widen_mult_hi_to_si_pattern_saved 1
         }
     }
@@ -3203,7 +3203,7 @@
              || [istarget i?86-*-*]
              || [istarget x86_64-*-*]
              || [istarget spu-*-*]
-             || ([istarget arm*-*-*] && [check_effective_target_arm_neon]
+             || ([istarget arm*-*-*] && [check_effective_target_arm_neon_ok]
 		 && [check_effective_target_arm_little_endian]) } {
             set et_vect_pack_trunc_saved 1
         }
@@ -3229,7 +3229,7 @@
              || [istarget x86_64-*-*] 
              || [istarget spu-*-*]
              || [istarget ia64-*-*]
-             || ([istarget arm*-*-*] && [check_effective_target_arm_neon]
+             || ([istarget arm*-*-*] && [check_effective_target_arm_neon_ok]
 		 && [check_effective_target_arm_little_endian]) } {
             set et_vect_unpack_saved 1
         }
@@ -3646,7 +3646,7 @@
     global et_vect_multiple_sizes_saved
 
     set et_vect_multiple_sizes_saved 0
-    if { ([istarget arm*-*-*] && [check_effective_target_arm_neon]) } {
+    if { ([istarget arm*-*-*] && [check_effective_target_arm_neon_ok]) } {
        set et_vect_multiple_sizes_saved 1
     }
     if { ([istarget x86_64-*-*] || [istarget i?86-*-*]) } {
@@ -3818,7 +3818,7 @@
 		}
 	    } ""
 	}]
-    } elseif { [istarget arm*-*-linux-gnueabi] } {
+    } elseif { [istarget arm*-*-linux-gnueabi*] } {
 	return [check_runtime sync_longlong_runtime {
 	    #include <stdlib.h>
 	    int main ()
@@ -3860,7 +3860,7 @@
 	     || [istarget i?86-*-*]
 	     || [istarget x86_64-*-*]
 	     || [istarget alpha*-*-*] 
-	     || [istarget arm*-*-linux-gnueabi] 
+	     || [istarget arm*-*-linux-gnueabi*] 
 	     || [istarget bfin*-*linux*]
 	     || [istarget hppa*-*linux*]
 	     || [istarget s390*-*-*] 
@@ -3890,7 +3890,7 @@
 	     || [istarget i?86-*-*]
 	     || [istarget x86_64-*-*]
 	     || [istarget alpha*-*-*] 
-	     || [istarget arm*-*-linux-gnueabi] 
+	     || [istarget arm*-*-linux-gnueabi*] 
 	     || [istarget hppa*-*linux*]
 	     || [istarget s390*-*-*] 
 	     || [istarget powerpc*-*-*]
Index: gcc/testsuite/gfortran.dg/enum_9.f90
===================================================================
--- gcc/testsuite/gfortran.dg/enum_9.f90	(.../tags/gcc_4_7_2_release)	(wersja 194650)
+++ gcc/testsuite/gfortran.dg/enum_9.f90	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -1,6 +1,6 @@
 ! { dg-do run }
 ! { dg-options "-fshort-enums" }
-! { dg-options "-fshort-enums -Wl,--no-enum-size-warning" { target arm*-*-linux*eabi } }
+! { dg-options "-fshort-enums -Wl,--no-enum-size-warning" { target arm*-*-linux*eabi* } }
 ! Program to test enumerations when option -fshort-enums is given
 
 program main
Index: gcc/testsuite/gfortran.dg/enum_10.f90
===================================================================
--- gcc/testsuite/gfortran.dg/enum_10.f90	(.../tags/gcc_4_7_2_release)	(wersja 194650)
+++ gcc/testsuite/gfortran.dg/enum_10.f90	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -1,7 +1,7 @@
 ! { dg-do run }
 ! { dg-additional-sources enum_10.c }
 ! { dg-options "-fshort-enums -w" }
-! { dg-options "-fshort-enums -w -Wl,--no-enum-size-warning" { target arm*-*-linux*eabi } }
+! { dg-options "-fshort-enums -w -Wl,--no-enum-size-warning" { target arm*-*-linux*eabi* } }
 ! Make sure short enums are indeed interoperable with the
 ! corresponding C type.
 
Index: gcc/testsuite/gfortran.dg/transfer_intrinsic_4.f
===================================================================
--- gcc/testsuite/gfortran.dg/transfer_intrinsic_4.f	(.../tags/gcc_4_7_2_release)	(wersja 0)
+++ gcc/testsuite/gfortran.dg/transfer_intrinsic_4.f	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -0,0 +1,27 @@
+! { dg-do compile }
+!
+! PR fortran/54818
+!
+! Contributed by  Scott Pakin
+!
+      subroutine broken ( name1, name2, bmix )
+
+      implicit none
+
+      integer, parameter :: i_knd  = kind( 1 )
+      integer, parameter :: r_knd  = selected_real_kind( 13 )
+
+      character(len=8) :: dum
+      character(len=8) :: blk
+      real(r_knd), dimension(*) :: bmix, name1, name2
+      integer(i_knd) :: j, idx1, n, i
+      integer(i_knd), external :: nafix
+
+      write (*, 99002) name1(j),
+     &     ( adjustl(
+     &     transfer(name2(nafix(bmix(idx1+i),1)),dum)//blk
+     &     //blk), bmix(idx1+i+1), i = 1, n, 2 )
+
+99002 format (' *', 10x, a8, 8x, 3(a24,1pe12.5,',',6x))
+
+      end subroutine broken
Index: gcc/testsuite/gfortran.dg/transfer_class_1.f90
===================================================================
--- gcc/testsuite/gfortran.dg/transfer_class_1.f90	(.../tags/gcc_4_7_2_release)	(wersja 0)
+++ gcc/testsuite/gfortran.dg/transfer_class_1.f90	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -0,0 +1,16 @@
+! { dg-do compile }
+! { dg-options "-Wsurprising" }
+!
+! PR 54917: [4.7/4.8 Regression] [OOP] TRANSFER on polymorphic variable causes ICE
+!
+! Contributed by Sean Santos <quantheory@gmail.com>
+
+subroutine test_routine1(arg)
+  implicit none
+  type test_type
+    integer :: test_comp
+  end type
+  class(test_type) :: arg
+  integer :: i
+  i = transfer(arg, 1)
+end subroutine
Index: gcc/testsuite/gfortran.dg/class_allocate_13.f90
===================================================================
--- gcc/testsuite/gfortran.dg/class_allocate_13.f90	(.../tags/gcc_4_7_2_release)	(wersja 0)
+++ gcc/testsuite/gfortran.dg/class_allocate_13.f90	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -0,0 +1,31 @@
+! { dg-do run }
+!
+! PR 54784: [4.7/4.8 Regression] [OOP] wrong code in polymorphic allocation with SOURCE
+!
+! Contributed by Jeremy Kozdon <jkozdon@gmail.com>
+
+program bug
+  implicit none
+
+  type :: block
+    real, allocatable :: fields
+  end type
+
+  type :: list
+    class(block),allocatable :: B
+  end type
+
+  type :: domain
+    type(list),dimension(2) :: L
+  end type
+
+  type(domain) :: d
+  type(block) :: b1
+
+  allocate(b1%fields,source=5.)
+  
+  allocate(d%L(2)%B,source=b1)           ! wrong code
+  
+  if (d%L(2)%B%fields/=5.) call abort()
+
+end program
Index: gcc/testsuite/gfortran.dg/allocate_error_4.f90
===================================================================
--- gcc/testsuite/gfortran.dg/allocate_error_4.f90	(.../tags/gcc_4_7_2_release)	(wersja 0)
+++ gcc/testsuite/gfortran.dg/allocate_error_4.f90	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -0,0 +1,16 @@
+! { dg-do compile }
+! PR fortran/55314 - the second allocate statement was rejected.
+
+program main
+  implicit none
+  integer :: max_nb
+  type comm_mask
+    integer(4), pointer :: mask(:)
+  end type comm_mask
+  type (comm_mask), allocatable, save :: encode(:,:)
+  max_nb=2
+  allocate( encode(1:1,1:max_nb))
+  allocate( encode(1,1)%mask(1),encode(1,2)%mask(1))
+  deallocate( encode(1,1)%mask,encode(1,2)%mask)
+  allocate( encode(1,1)%mask(1),encode(1,1)%mask(1))  ! { dg-error "also appears at" }
+end program main
Index: gcc/testsuite/gfortran.dg/namelist_76.f90
===================================================================
--- gcc/testsuite/gfortran.dg/namelist_76.f90	(.../tags/gcc_4_7_2_release)	(wersja 0)
+++ gcc/testsuite/gfortran.dg/namelist_76.f90	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -0,0 +1,28 @@
+! { dg-do compile }
+!
+! PR 55352: [4.7/4.8 Regression] Erroneous gfortran warning of unused module variable when variable is only used in namelist
+!
+! Contributed by <AstroFloyd@gmail.com>
+
+module data
+  implicit none
+  integer :: a
+end module data
+
+program test
+  use data, only: a
+  implicit none
+  a = 1
+  call write_data()
+end program test
+
+subroutine write_data()
+  use data, only: a
+  implicit none
+  namelist /write_data_list/ a
+  open(unit=10,form='formatted',status='replace',action='write',file='test.dat')
+  write(10, nml=write_data_list)
+  close(10)
+end subroutine write_data
+
+! { dg-final { cleanup-modules "data" } }
Index: gcc/testsuite/gcc.c-torture/execute/pr54985.c
===================================================================
--- gcc/testsuite/gcc.c-torture/execute/pr54985.c	(.../tags/gcc_4_7_2_release)	(wersja 0)
+++ gcc/testsuite/gcc.c-torture/execute/pr54985.c	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -0,0 +1,36 @@
+
+typedef struct st {
+    int a;
+} ST;
+
+int __attribute__((noinline,noclone))
+foo(ST *s, int c)
+{
+  int first = 1;
+  int count = c;
+  ST *item = s;
+  int a = s->a;
+  int x;
+
+  while (count--)
+    {
+      x = item->a;
+      if (first)
+        first = 0;
+      else if (x >= a)
+        return 1;
+      a = x;
+      item++;
+    }
+  return 0;
+}
+
+extern void abort (void);
+
+int main ()
+{
+  ST _1[2] = {{2}, {1}};
+  if (foo(_1, 2) != 0)
+    abort ();
+  return 0;
+}
Index: gcc/testsuite/gcc.c-torture/compile/20121107-1.c
===================================================================
--- gcc/testsuite/gcc.c-torture/compile/20121107-1.c	(.../tags/gcc_4_7_2_release)	(wersja 0)
+++ gcc/testsuite/gcc.c-torture/compile/20121107-1.c	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -0,0 +1,14 @@
+/* PR middle-end/55219 */
+/* Testcase by Markus Trippelsdorf <markus@trippelsdorf.de> */
+
+int x, c, d, e, f, g, h, i;
+double j;
+const int k;
+const enum { B } a;
+void
+fn1 (void)
+{
+  h = (g ? c : g ? f : g ? e : g ? i : g ? f : g ? e : g ? d : x)
+      + (a ? : a ? : a ? : a ? : a ? : a ? : a ? : a ? : a ? : a ? : a
+         ? j : a ? : 0 ? : a ? : a ? : a ? : a ? : a ? : a ? k : a ? : x);
+}
Index: gcc/testsuite/gcc.c-torture/compile/pr54103-2.c
===================================================================
--- gcc/testsuite/gcc.c-torture/compile/pr54103-2.c	(.../tags/gcc_4_7_2_release)	(wersja 0)
+++ gcc/testsuite/gcc.c-torture/compile/pr54103-2.c	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -0,0 +1,5 @@
+void
+f (void)
+{
+  0 / 0 || 0 ? : 0;
+}
Index: gcc/testsuite/gcc.c-torture/compile/pr54103-4.c
===================================================================
--- gcc/testsuite/gcc.c-torture/compile/pr54103-4.c	(.../tags/gcc_4_7_2_release)	(wersja 0)
+++ gcc/testsuite/gcc.c-torture/compile/pr54103-4.c	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -0,0 +1,5 @@
+void
+f (void)
+{
+  0 / 0 && 1 ? : 0;
+}
Index: gcc/testsuite/gcc.c-torture/compile/pr54103-6.c
===================================================================
--- gcc/testsuite/gcc.c-torture/compile/pr54103-6.c	(.../tags/gcc_4_7_2_release)	(wersja 0)
+++ gcc/testsuite/gcc.c-torture/compile/pr54103-6.c	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -0,0 +1,5 @@
+void
+f (void)
+{
+  0 || 65536*65536 ? : 0;
+}
Index: gcc/testsuite/gcc.c-torture/compile/pr54552-1.c
===================================================================
--- gcc/testsuite/gcc.c-torture/compile/pr54552-1.c	(.../tags/gcc_4_7_2_release)	(wersja 0)
+++ gcc/testsuite/gcc.c-torture/compile/pr54552-1.c	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -0,0 +1,8 @@
+void
+f (void)
+{
+  unsigned n = 10;
+
+  typedef double T[n];
+  (double (*)[n])((unsigned char (*)[sizeof (T)]){ 0 });
+}
Index: gcc/testsuite/gcc.c-torture/compile/pr54103-1.c
===================================================================
--- gcc/testsuite/gcc.c-torture/compile/pr54103-1.c	(.../tags/gcc_4_7_2_release)	(wersja 0)
+++ gcc/testsuite/gcc.c-torture/compile/pr54103-1.c	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -0,0 +1,5 @@
+void
+f (void)
+{
+  0 || 0 / 0 ? : 0;
+}
Index: gcc/testsuite/gcc.c-torture/compile/pr54103-3.c
===================================================================
--- gcc/testsuite/gcc.c-torture/compile/pr54103-3.c	(.../tags/gcc_4_7_2_release)	(wersja 0)
+++ gcc/testsuite/gcc.c-torture/compile/pr54103-3.c	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -0,0 +1,5 @@
+void
+f (void)
+{
+  1 && 0 / 0 ? : 0;
+}
Index: gcc/testsuite/gcc.c-torture/compile/pr54103-5.c
===================================================================
--- gcc/testsuite/gcc.c-torture/compile/pr54103-5.c	(.../tags/gcc_4_7_2_release)	(wersja 0)
+++ gcc/testsuite/gcc.c-torture/compile/pr54103-5.c	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -0,0 +1,5 @@
+void
+f (void)
+{
+  !(0 / 0);
+}
Index: gcc/testsuite/gnat.dg/opt20.adb
===================================================================
--- gcc/testsuite/gnat.dg/opt20.adb	(.../tags/gcc_4_7_2_release)	(wersja 194650)
+++ gcc/testsuite/gnat.dg/opt20.adb	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -1,3 +1,6 @@
+-- { dg-do compile }
+-- { dg-options "-O2 -gnatpn" }
+
 with Ada.Characters.Handling; use Ada.Characters.Handling;
 
 package body Opt20 is
Index: gcc/testsuite/gnat.dg/modular4_pkg.ads
===================================================================
--- gcc/testsuite/gnat.dg/modular4_pkg.ads	(.../tags/gcc_4_7_2_release)	(wersja 0)
+++ gcc/testsuite/gnat.dg/modular4_pkg.ads	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -0,0 +1,9 @@
+package Modular4_Pkg is
+
+   type Word is mod 2**48;
+
+   Zero : constant Word := 0;
+
+   function F return Word;
+
+end Modular4_Pkg;
Index: gcc/testsuite/gnat.dg/opt20.ads
===================================================================
--- gcc/testsuite/gnat.dg/opt20.ads	(.../tags/gcc_4_7_2_release)	(wersja 194650)
+++ gcc/testsuite/gnat.dg/opt20.ads	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -1,6 +1,3 @@
--- { dg-do compile }
--- { dg-options "-O2 -gnatpn" }
-
 with Opt20_Pkg; use Opt20_Pkg;
 
 package Opt20 is
Index: gcc/testsuite/gnat.dg/addr1.adb
===================================================================
--- gcc/testsuite/gnat.dg/addr1.adb	(.../tags/gcc_4_7_2_release)	(wersja 194650)
+++ gcc/testsuite/gnat.dg/addr1.adb	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -1,3 +1,5 @@
+--  { dg-do compile }
+
 with System;
 package body addr1 is
    task type T is
Index: gcc/testsuite/gnat.dg/addr1.ads
===================================================================
--- gcc/testsuite/gnat.dg/addr1.ads	(.../tags/gcc_4_7_2_release)	(wersja 194650)
+++ gcc/testsuite/gnat.dg/addr1.ads	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -1,5 +1,3 @@
---  { dg-do compile }
-
 package addr1 is
    pragma Elaborate_Body;
 end;
Index: gcc/testsuite/gnat.dg/discr23.ads
===================================================================
--- gcc/testsuite/gnat.dg/discr23.ads	(.../tags/gcc_4_7_2_release)	(wersja 194650)
+++ gcc/testsuite/gnat.dg/discr23.ads	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -1,5 +1,3 @@
--- { dg-do compile }
-
 package Discr23 is
 
   procedure Dummy;
Index: gcc/testsuite/gnat.dg/stack_check3.adb
===================================================================
--- gcc/testsuite/gnat.dg/stack_check3.adb	(.../tags/gcc_4_7_2_release)	(wersja 0)
+++ gcc/testsuite/gnat.dg/stack_check3.adb	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -0,0 +1,36 @@
+-- { dg-do compile }
+-- { dg-options "-O -fstack-check" }
+
+package body Stack_Check3 is
+
+  type Int_Arr is array (1 .. 34) of Integer;
+
+  type Rec (D : Boolean := False) is
+    record
+      case D is
+        when True  => IA : Int_Arr;
+        when False => null;
+      end case;
+    end record;
+
+  type Rec_Arr is array (1 .. 256) of Rec;
+
+  protected Prot_Arr is
+    procedure Reset;
+  private
+    A : Rec_Arr;
+  end Prot_Arr;
+
+  protected body Prot_Arr is
+    procedure Reset is
+    begin
+      A := (others => (D => False));
+    end Reset;
+  end Prot_Arr;
+
+  procedure Reset is
+  begin
+    Prot_Arr.Reset;
+  end Reset;
+
+end Stack_Check3;
Index: gcc/testsuite/gnat.dg/stack_check3.ads
===================================================================
--- gcc/testsuite/gnat.dg/stack_check3.ads	(.../tags/gcc_4_7_2_release)	(wersja 0)
+++ gcc/testsuite/gnat.dg/stack_check3.ads	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -0,0 +1,5 @@
+package Stack_Check3 is
+
+  procedure Reset;
+
+end Stack_Check3;
Index: gcc/testsuite/gnat.dg/modular4.adb
===================================================================
--- gcc/testsuite/gnat.dg/modular4.adb	(.../tags/gcc_4_7_2_release)	(wersja 0)
+++ gcc/testsuite/gnat.dg/modular4.adb	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -0,0 +1,11 @@
+-- { dg-do compile }
+-- { dg-options "-O" }
+
+with Modular4_Pkg; use Modular4_Pkg;
+
+procedure Modular4 is
+begin
+  for I in Zero .. F mod 8 loop
+    raise Program_Error;
+  end loop;
+end;
Index: gcc/testsuite/gnat.dg/concat2.adb
===================================================================
--- gcc/testsuite/gnat.dg/concat2.adb	(.../tags/gcc_4_7_2_release)	(wersja 194650)
+++ gcc/testsuite/gnat.dg/concat2.adb	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -1,3 +1,6 @@
+-- { dg-do compile }
+-- { dg-options "-O" }
+
 with Text_IO; use Text_IO;
 
 package body Concat2 is
@@ -15,4 +18,3 @@
    end;
 
 end Concat2;
-
Index: gcc/testsuite/gnat.dg/controlled7.adb
===================================================================
--- gcc/testsuite/gnat.dg/controlled7.adb	(.../tags/gcc_4_7_2_release)	(wersja 0)
+++ gcc/testsuite/gnat.dg/controlled7.adb	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -0,0 +1,18 @@
+-- PR ada/53766
+-- Reported by Duncan Sands <baldrick@gcc.gnu.org>
+
+-- { dg-do compile }
+-- { dg-options "-gnatp" }
+
+with Ada.Strings.Unbounded; use Ada.Strings.Unbounded;
+
+package body Controlled7 is
+
+   procedure Proc (Offset : Storage_Offset) is
+   begin
+      if Offset + Unbounded_String'Max_Size_In_Storage_Elements >= 16 then
+         raise Program_Error;
+      end if;
+   end;
+
+end Controlled7;
Index: gcc/testsuite/gnat.dg/concat2.ads
===================================================================
--- gcc/testsuite/gnat.dg/concat2.ads	(.../tags/gcc_4_7_2_release)	(wersja 194650)
+++ gcc/testsuite/gnat.dg/concat2.ads	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -1,6 +1,3 @@
--- { dg-do compile }
--- { dg-options "-O" }
-
 package Concat2 is
 
    procedure Browse;
Index: gcc/testsuite/gnat.dg/controlled7.ads
===================================================================
--- gcc/testsuite/gnat.dg/controlled7.ads	(.../tags/gcc_4_7_2_release)	(wersja 0)
+++ gcc/testsuite/gnat.dg/controlled7.ads	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -0,0 +1,7 @@
+with System.Storage_Elements; use System.Storage_Elements;
+
+package Controlled7 is
+
+  procedure Proc (Offset : Storage_Offset);
+
+end Controlled7;
Index: gcc/testsuite/gnat.dg/vect8.adb
===================================================================
--- gcc/testsuite/gnat.dg/vect8.adb	(.../tags/gcc_4_7_2_release)	(wersja 194650)
+++ gcc/testsuite/gnat.dg/vect8.adb	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -1,3 +1,6 @@
+-- { dg-do compile }
+-- { dg-options "-w" }
+
 package body Vect8 is
 
    function Foo (V : Vec) return Vec is
Index: gcc/testsuite/gnat.dg/lto14.adb
===================================================================
--- gcc/testsuite/gnat.dg/lto14.adb	(.../tags/gcc_4_7_2_release)	(wersja 194650)
+++ gcc/testsuite/gnat.dg/lto14.adb	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -1,5 +1,6 @@
 -- { dg-do link }
 -- { dg-options "-largs -f -margs -flto" { target lto } }
+-- { dg-skip-if "missing linker support" { *-*-solaris2.* } }
 
 procedure Lto14 is
 begin
Index: gcc/testsuite/gnat.dg/vect8.ads
===================================================================
--- gcc/testsuite/gnat.dg/vect8.ads	(.../tags/gcc_4_7_2_release)	(wersja 194650)
+++ gcc/testsuite/gnat.dg/vect8.ads	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -1,5 +1,3 @@
--- { dg-do compile }
-
 package Vect8 is
 
    type Vec is array (1 .. 2) of Long_Float;
Index: gcc/testsuite/gnat.dg/array16.adb
===================================================================
--- gcc/testsuite/gnat.dg/array16.adb	(.../tags/gcc_4_7_2_release)	(wersja 194650)
+++ gcc/testsuite/gnat.dg/array16.adb	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -1,3 +1,6 @@
+-- { dg-do compile }
+-- { dg-options "-O -gnatn -fdump-tree-optimized" }
+
 package body Array16 is
 
   function F1 (A : access My_T1) return My_T1 is
@@ -20,3 +23,6 @@
   end;
 
 end Array16;
+
+-- { dg-final { scan-tree-dump-not "secondary_stack" "optimized" } }
+-- { dg-final { cleanup-tree-dump "optimized" } }
Index: gcc/testsuite/gnat.dg/array16.ads
===================================================================
--- gcc/testsuite/gnat.dg/array16.ads	(.../tags/gcc_4_7_2_release)	(wersja 194650)
+++ gcc/testsuite/gnat.dg/array16.ads	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -1,6 +1,3 @@
--- { dg-do compile }
--- { dg-options "-O -gnatn -fdump-tree-optimized" }
-
 with Array16_Pkg;
 
 package Array16 is
@@ -26,6 +23,3 @@
   procedure Proc (A : access My_T1; B : access My_T2);
 
 end Array16;
-
--- { dg-final { scan-tree-dump-not "secondary_stack" "optimized" } }
--- { dg-final { cleanup-tree-dump "optimized" } }
